#!/bin/bash
cd `dirname $BASH_SOURCE`
cd ../images
if [ -z "`which inkscape`" ]
then
    echo 'ERROR: inkscape command not found. run "apt-get install inkscape" to install.'
    exit 1
fi
if [ -z "`which optipng`" ]
then
    echo 'ERROR: optipng command not found. run "apt-get install optipng" to install.'
    exit 1
fi
for i in *.svg
do
    name=`basename $i .svg`
    inkscape --export-png=$name.png $name.svg
done
optipng -quiet -o7 -strip all *.png
